import random
from itertools import product
from itertools import permutations
import tkinter as tk
from tkinter import ttk
import sys
import os
import platform

value_f1=0
value_otv=[]
value_user_otv=[]
def start_win():
    global value_f1
    root = tk.Tk()
    root.title("Позорное окно")
    if platform.system() == 'Windows':
        root.geometry('200x95')
    else:
        root.geometry('260x125')

    label = tk.Label(root, text="Выберите сложность:")
    label.grid(row=0,column=0)

    def on_closing():
        if root.winfo_exists():
            print("Окно еще открыто")

    def set_difficulty(x):
        root.difficulty = x
        root.destroy()  # Закрыть окно после выбора сложности

    def test():
        root.flag = True
        root.destroy()

    def close_program():
        if platform.system() == 'Windows':
            sys.exit()
        else:
            os.system('pkill -9 python')

    easy_button = tk.Button(root, text="  Легко  ", command=lambda: set_difficulty("Easy"))
    easy_button.grid(row=1,column=0)

    medium_button = tk.Button(root, text=" Средне ", command=lambda: set_difficulty("Medium"))
    medium_button.grid(row=2,column=0)

    hard_button = tk.Button(root, text="Сложно", command=lambda: set_difficulty("Hard"))
    hard_button.grid(row=3,column=0)


    test_button = tk.Button(root, text="  Тест  ", command=lambda: test())
    test_button.grid(row=1,column=1)

    exit = tk.Button(root, text="Выход", command=close_program)
    exit.grid(row=2,column=1)

    root.protocol("WM_DELETE_WINDOW", on_closing)

    root.flag = False
    root.difficulty = None
    root.mainloop()


    return root.flag, root.difficulty


class Generate:
    def show(self):
        global value_f1, value_otv, count, value_i
        if value_function[0]==True:
            self.selected_difficulty = random.choice(['Easy', 'Medium', 'Hard'])
            Generate.generator(self)
            if value_f1==0:
                value_f1+=1
                Generate.test(self)
        else:
            self.selected_difficulty = value_function[1]
            Generate.generator(self)

        self.frame = ttk.Frame(notebook)
        self.text_widget = tk.Text(self.frame, wrap="word", height=16, width=50)
        self.text_widget.insert(tk.END, self.main_text)
        self.text_widget.config()
        self.text_widget.grid(row=1,column=0,columnspan=5, stick='nswe')
        if value_function[0]==False:
            self.square = tk.Frame(self.frame, width=400, height=5, bg="white", highlightbackground="black",
                               highlightthickness=1)
            self.square.grid(row=0, column=0,columnspan=2, stick='nswe')
        if value_function[0]==True and count!=9:
            notebook.add(self.frame, text=f"З {value_i}")
            notebook.grid(row=0,rowspan=2,column=0,columnspan=5)
            value_otv.append(str(Generate.examinate(self)))
        elif value_function[0]==False:
            notebook.add(self.frame, text=f"Задача {count+1}")
            notebook.grid(row=0, rowspan=2, column=0, columnspan=5)

            value_otv.append(str(Generate.examinate(self)))


    def get_entry_value(self):
        global current_timer
        if len(entry.get())>10:
            print('введите корректный ответ')
        else:
            if value_function[0]:
                value_user_otv.append(entry.get())
                if len(value_user_otv)==10:
                    count=0
                    for i in range(0,10):
                        notebook.tab(i, state='normal')
                    for i in range(0,10):
                        notebook.forget(notebook.index("current"))
                        win1.after_cancel(current_timer)
                        entry.destroy()
                        button_ex.destroy()
                        button_exit.destroy()
                        timer.destroy()

                        win1.geometry("200x276")
                    for i in range(10):
                        if value_otv[i]==value_user_otv[i]:
                            count+=1
                    pr=tk.Label(text=f'Вы набрали {count} верных ответов')
                    l = tk.Label(text=f'полученный ответ')
                    l.grid(row=0,column=0)
                    l = tk.Label(text=f'верный ответ')
                    l.grid(row=0, column=1)
                    for i in range(10):
                        l=tk.Label(text=f'{value_user_otv[i]}')
                        l.grid(row=i+1,column=0)
                        l=tk.Label(text=f'{value_otv[i]}')
                        l.grid(row=i + 1, column=1)
                    pr.grid(row=i+2,column=0,columnspan=2)
                    button = tk.Button(win1, text="Начальное окно", command=restart_program)
                    button.grid(row=i+3,column=0,columnspan=2)
                else:
                    if current_timer:
                        win1.after_cancel(current_timer)
                        countdown(180)
                    notebook.tab(notebook.index("current") + 1, state='normal')
                    notebook.tab(notebook.index("current"), state='disabled')
            else:
                if str(entry.get()) == value_otv[notebook.index("current")]:
                    Generate.change_color_right(self)
                    print(entry.get(),value_otv[notebook.index("current")],"Правильно")
                else:
                    Generate.change_color_false(self)
                    print(entry.get(),value_otv[notebook.index("current")],"Неправильно")
        if len(value_user_otv)!=10:
            entry.delete(0, "end")

    def change_color_right(self):
        self.square.config(bg='#00FF00')

    def change_color_false(self):
        self.square.config( bg='#FF0000')

    def generator(self):
        alph = [ord("А"),ord("У"),ord("О") ,ord("И") ,ord("Э") ,ord("Я"),ord("Ю"),ord("Е")]

        count=[]
        self.scale = random.randint(4, 6)
        self.scale_word=self.scale+random.randint(1,2)
        self.word=[]
        self.position=random.choice(['начинается','заканчивается'])
        self.value=[]
        self.value1=[]
        self.value2=[]
        self.count_for3_m=0
        combinations_example=''
        if self.selected_difficulty=='Easy':
            self.num=random.randint(1,3)
        else:
            self.num=random.randint(1,2)
        if self.num == 3 and self.selected_difficulty == 'Medium' or self.num==2 and self.selected_difficulty=='Medium'or self.num==2 and self.selected_difficulty=='Hard':
            self.value1 = random.choice(['гласныe', 'согласныe'])
            self.value2 = random.choice(['гласные', 'согласные'])

        for i in range(self.scale):
            if self.num==3 and self.selected_difficulty=='Medium' or self.num==2 and self.selected_difficulty=='Medium'or self.num==3 and self.selected_difficulty=='Hard':
                if self.value1=='гласныe' and self.count_for3_m<self.scale//2 or self.value2=='гласныe' and self.count_for3_m<self.scale//2:
                    a=random.choice(alph)
                    self.count_for3_m+=1
                elif self.value1=='согласныe' and self.count_for3_m<self.scale//2 or self.value2=='согласные' and self.count_for3_m<self.scale//2:
                    a=random.choice([i for i in range(1040,1072) if i not in alph])
                    self.count_for3_m += 1
                # elif self.value1=='гласныe' and self.count_for3_m>=self.scale//2:
                #     a=random.choice([i for i in range(1040,1072) if i not in alph])
                # elif self.value1=='согласныe' and self.count_for3_m>=self.scale//2:
                #     a=random.choice(alph)
                else:
                    a = random.randint(1040, 1071)
            else:
                a = random.randint(1040, 1071)
            if a in count:
                while a in count:

                    a = random.randint(1040, 1071)
            if a == 1066 or a == 1067 or a == 1068:
                while a == 1066 or a == 1067 or a == 1068:
                    a = random.randint(1040, 1071)
            self.word.append(chr(a))
            self.word = sorted(self.word)
            count.append(a)

        if self.num in [4, 5, 6]:
            self.scale_word = len(self.word)
            for i, x in enumerate(permutations(''.join(self.word))):
                if i == self.scale:
                    break
                combinations_example += f'\n{i + 1}: {",".join(x)}'
        else:
            for i, x in enumerate(product(''.join(self.word), repeat=self.scale_word)):
                if i == self.scale:
                    break
                combinations_example += f'\n{i + 1}: {",".join(x)}'
        self.word1 = self.word[:]
        text = f'Все {self.scale_word}-буквенные слова, составленные из букв {", ".join(self.word)}, записаны в алфавитном порядке.\n Вот начало списка: {combinations_example}\n... \n'
        text1=''
        if self.selected_difficulty=='Easy':
            if self.num==1 :
                vl=len(self.word)**self.scale_word
                self.value=random.randint(10, vl)
                text1+=f'Запишите слово, которое стоит на {self.value}-м месте от начала списка.'
            elif self.num==2:
                self.value = random.choice([i for i in self.word if i!=self.word[0] and i!=self.word[-1]])
                if self.position=='начинается':
                    text1 += f'Укажите номер последнего слова, которое {self.position} с буквы {self.value}.'
                else:
                    text1 += f'Укажите номер последнего слова, которое {self.position} на букву {self.value}.'
            elif self.num==3:
                self.value = random.choice(self.word)
                text1 += f'Причём буква {self.value} появляется ровно 1 раз. Каждая из других допустимых букв может встречаться в кодовом слове любое количество раз или не встречаться совсем. Сколько различных кодовых слов можно использовать?'


        if self.selected_difficulty=='Medium':
            self.value = random.choice([i for i in self.word if i!=self.word[0] if i!=self.word[-1]])
            self.word.pop(self.word.index(self.value))
            if self.num==1 or self.num==4:
                self.value1 = random.choice([i for i in self.word if i != self.word[0] if i != self.word[-1]])
                if self.num==1:
                    text1 += f'Каждую букву можно использовать любое количество раз.Укажите номер первого слова, которое начинается с буквы {self.value} и заканчивается {self.value1}.'
            elif self.num==2 or self.num==3:
                text1 += f'Каждую букву можно использовать любое количество раз, при этом нельзя ставить рядом две {self.value1}. Сколько различных последовательностей можно составить?'
        if self.selected_difficulty=='Hard':
            self.value = random.choice(self.word)
            self.word.pop(self.word.index(self.value))
            self.value1 = random.choice(self.word)
            if self.num==1:
                self.value2 = random.choice(self.word)
                text1 += f'Буквы {self.value} и {self.value1} нужно обязательно использовать ровно по одному разу, букву {self.value2} можно использовать один раз или не использовать совсем, остальные буквы можно использовать произвольное количество раз или не использовать совсем. Сколько различных кодов можно составить?'
            if self.num==2:
                self.position = random.choice(['начинаться', 'заканчиваться'])
                text1 += f'Каждую букву можно использовать любое количество раз, при этом последовательность не может {self.position} с буквы {self.value}, должна содержать хотя бы одну {self.value1}, а так же две подряд идущие {self.value2}. Сколько различных кодов можно составить?'

        self.main_text=text+text1

    def examinate(self):
        alph=['А','У','О','И','Э','Ы','Я','Ю','Е','Ё ']

        self.count=0
        if self.num in [1,2,3]:
            for i,x in enumerate(product(self.word1,repeat=self.scale_word)):
                if self.selected_difficulty=='Easy':
                    if self.num==1:
                        if i+1==self.value:
                            return "".join(x)
                    elif self.num==2:
                        if self.position=='начинается':
                            if x[0]==self.value:
                                self.count=i+1
                        if self.position=='заканчивается':
                            if x[-1]==self.value:
                                self.count=i+1
                    elif self.num==3:
                        if x.count(str(self.value))==1:
                            self.count+=1
                if self.selected_difficulty=='Medium':
                    if self.num==1:
                        if x[0]==self.value and x[-1]==self.value1:
                            return i+1

                    if self.num==2 or self.num==3:
                        local_count=0
                        for j in range(self.scale_word-1):
                            if self.value1=="согласныe":
                                if x[j] not in alph and x[j + 1] not in alph:
                                    break
                                else:
                                    local_count += 1
                            else:
                                if x[j]  in alph and x[j + 1]  in alph:
                                    break
                                else:
                                    local_count += 1
                        if local_count == len(x) - 1:
                            self.count += 1

                if self.selected_difficulty == 'Hard':
                    if self.num == 1:
                        if x.count(self.value) == 1 and x.count(self.value1) == 1 and (x.count(self.value2) == 1 or x.count(self.value2) == 0):
                            self.count+=1
                    elif self.num==2:
                        if self.position=="начинаться":
                            if x[0] != self.value and x.count(self.value1) >= 1:
                                if self.value2=="согласныe":
                                    for j in range(len(x) - 1):
                                        if x[j] not in alph and x[j + 1] not in alph:
                                            self.count += 1
                                else:
                                    for j in range(len(x) - 1):
                                        if x[j]  in alph and x[j + 1]  in alph:
                                            self.count += 1
                        elif self.position=="заканчиваться":
                            if x[-1] != self.value and x.count(self.value1) >= 1:
                                if self.value2 == "гласные":
                                    for j in range(len(x) - 1):
                                        if x[j]  in alph and x[j + 1]  in alph:
                                            self.count += 1
                                else:
                                    for j in range(len(x) - 1):
                                        if x[j] not in alph and x[j + 1] not in alph:
                                            self.count += 1

            return self.count




    def exit(self):
        win1.destroy()

    def next(self):
        global count
        count += 1
        self.new_tab = Generate()
        tabs[count] = self.new_tab
        self.new_tab.show()

    def test(self):
        global count,value_i
        for i in range(0,10):
            self.new_tab = Generate()
            value_i = i+1
            tabs[i] = self.new_tab
            self.new_tab.show()
            if i > 0:
                notebook.tab(i, state='disabled')  # Заблокировать вкладку
        count=i

    def DelTab(self):
        global count
        value=notebook.index("current")
        if count > 0:
            count -= 1
            notebook.forget(notebook.index("current"))
            for i in range(value,len(tabs)-1):
                tabs[i]=tabs[i+1]
        else:
            print('осталась одна вкладка')


def countdown(count):
    global current_timer
    if current_timer:
        win1.after_cancel(current_timer)  # Отменяем предыдущий таймер, если он был установлен
    timer.config(text=str(count))
    if count > 0:
        current_timer = win1.after(1000, countdown, count - 1)  # Устанавливаем новый таймер
    else:
        Generate.get_entry_value(count)

def toggle_visibility(event):
    value=notebook.index('current')
    otv.config(text=f"{value_otv[value]}")

def restart_program():
    python = sys.executable
    os.execl(python, python, *sys.argv)

count=0
value_i=0
current_timer=None
value_function=start_win()
win1 = tk.Tk()
win1.title('задача')
tabs=dict()
notebook = ttk.Notebook(win1)
print("Если кнопки 'начальное окно' и 'выход' не работают - виновата школьная ОС, а не разработчик, запускал на эмуляторе убунту, всё работает")
if value_function[0]==False:
    standart=Generate()
    standart.show()
    tabs[0]=standart
    button_back = tk.Button(win1, text="Следующая задача", command=lambda: tabs[notebook.index("current")].next())
    button_back.grid(row=2, column=2, stick='e')
    button_back = tk.Button(win1, text="Удалить вкладку", command=lambda: tabs[notebook.index("current")].DelTab())
    button_back.grid(row=2, column=4, stick='e')
    otv = tk.Label(win1, text="смотреть ответ")
    otv.grid(row=3, column=0)
    otv.bind("<Button-1>", toggle_visibility)
    button = tk.Button(win1, text="Начальное окно", command=restart_program)
    button.grid(row=3, column=2, stick='nsew')
    button_exit = tk.Button(win1, text="Выйти", command=lambda: tabs[notebook.index("current")].exit())
    button_exit.grid(row=3, column=4, stick='nsew')
else:
    standart = Generate()
    standart.show()
    timer = tk.Label(win1, font=('Arial', 10))
    timer.grid(row=2, column=2, stick='e')
    countdown(180)
    button_exit = tk.Button(win1, text="Выйти", command=lambda: tabs[notebook.index("current")].exit())
    button_exit.grid(row=2, column=4, stick='nsew')

entry = tk.Entry(win1)
entry.grid( row=2,column=0,stick='e')
button_ex = tk.Button(win1, text="Ответить", command=lambda: tabs[notebook.index("current")].get_entry_value())
button_ex.grid(row=2,column=1,stick='e')




win1.mainloop()



